package ru.dbotthepony.mc.otm.screen;

import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.menu.DriveViewerMenu;
import ru.dbotthepony.mc.otm.menu.MatteryMenu;
import ru.dbotthepony.mc.otm.menu.slot.BatterySlot;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;
import ru.dbotthepony.mc.otm.menu.widget.GaugeWidget;
import ru.dbotthepony.mc.otm.screen.panels.*;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public class DriveViewerScreen extends MatteryScreen<DriveViewerMenu> implements MatteryScreen.IMatteryScreenGaugeGetter, MatteryScreen.IMatteryScreenBatteryGetter {
	public static final int FRAME_WIDTH = 210;
	public static final int FRAME_HEIGHT = 100;

	public DriveViewerScreen(DriveViewerMenu menu, Inventory inventory, Component title) {
		super(menu, inventory, title);
	}

	@Override
	public List<GaugeWidget> getGauges() {
		return List.of(menu.battery_widget);
	}

	@Override
	public List<MatterySlot> getBatterySlots() {
		return List.of(menu.battery_slot, menu.drive_slot);
	}

	@Nullable
	@Override
	protected FramePanel makeMainFrame() {
		var frame = new FramePanel(this, null, 0, 0, FRAME_WIDTH, FRAME_HEIGHT, getTitle());

		autoAttachToFrame(frame);

		var grid = new GridPanel(this, frame, 0, 0, 0, 0, 3, 3);
		grid.setDock(Dock.FILL);

		for (int i = 0; i < 9; i++) {
			final int index = i;

			new AbstractSlotPanel(this, grid, 0, 0) {
				@Nonnull
				@Override
				protected ItemStack getItemStack() {
					var view = menu.getView();

					if (view != null) {
						var list = view.getItems();

						if (index >= list.size()) {
							return ItemStack.EMPTY;
						}

						return list.get(index);
					}

					return ItemStack.EMPTY;
				}
			};
		}

		return frame;
	}
}
